【HDU】1937Finding Seats(枚举前缀和,尺取)

Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 911    Accepted Submission(s): 304


 

Problem Description

A group of K friends is going to see a movie. However, they are too late to get good tickets, so they are looking for a good way to sit all nearby. Since they are all science students, they decided to come up with an optimization problem instead of going on with informal arguments to decide which tickets to buy.

The movie theater has R rows of C seats each, and they can see a map with the currently available seats marked. They decided that seating close to each other is all that matters, even if that means seating in the front row where the screen is so big it’s impossible to see it all at once. In order to have a formal criteria, they thought they would buy seats in order to minimize the extension of their group.

The extension is defined as the area of the smallest rectangle with sides parallel to the seats that contains all bought seats. The area of a rectangle is the number of seats contained in it.

They’ve taken out a laptop and pointed at you to help them find those desired seats.

 

 

Input

Each test case will consist on several lines. The first line will contain three positive integers R, C and K as explained above (1 <= R,C <= 300, 1 <= K <= R × C). The next R lines will contain exactly C characters each. The j-th character of the i-th line will be ‘X’ if the j-th seat on the i-th row is taken or ‘.’ if it is available. There will always be at least K available seats in total.
Input is terminated with R = C = K = 0.

 

 

Output

For each test case, output a single line containing the minimum extension the group can have.

 

 

Sample Input

 

3 5 5 ...XX .X.XX XX... 5 6 6 ..X.X. .XXX.. .XX.X. .XXX.X .XX.XX 0 0 0

 

 

Sample Output

 

6 9

 

 

Source

ACM South American Programming Contest 2007

 

 

Recommend

lcy

 

 

Statistic | Submit | Discuss | Note

 

题目大意:某电影院有R排C列,然后有k个朋友去看电影,电影院还有些空座,然后求解他们k个人最后坐下的面积最小为多少,

思路:这个题目的话,首先要知道怎么统计某个矩形中的“.”的个数,也就是座位的个数,

这里就想到了我们概率论中那个划分概率区间的一个图了,下面画给大家

从上面的图中,我们可以看出,就是四个顶点的左上方的区域,然后做一个容斥,就得到了四个顶点中的面积,

我们这里的座位数目也是这个道理

#include<iostream>
#include<algorithm>
#include<cstring>
#include<cstdio>
#define inf 0x3f3f3f3f
using namespace std;
const int maxn=400;

char st[maxn][maxn];
int sum[maxn][maxn];
int num[maxn][maxn];
int r,c,k;


int main()
{
    while(scanf("%d%d%d",&r,&c,&k)!=EOF)
    {
        if(r==0&&c==0&&k==0)
            break;
        for(int i=1; i<=r; i++)
        {
            scanf("%s",st[i]+1);
            for(int j=1; j<=c; j++)
            {
                if(st[i][j]=='.')
                    num[i][j]=1;
                else
                    num[i][j]=0;
                sum[i][j]=sum[i][j-1]+num[i][j];
            }
        }
        for(int i=2; i<=r; i++)
            for(int j=1; j<=c; j++)
                sum[i][j]+=sum[i-1][j];
        int ans=inf;
        for(int i=1; i<=c; i++) //枚举第一条竖线
            for(int j=i; j<=c; j++)//枚举第二条竖线
            {
                int sta=1;                //对于横线的尺取
                for(int t=1; t<=r; t++)
                {
                    while(sum[t][j]-sum[t][i-1]-sum[sta-1][j]+sum[sta-1][i-1]>=k)
                    {
                        ans=min(ans,(j-i+1)*(t-sta+1));
                        sta++;
                    }
                }
            }
        printf("%d\n",ans);
    }
    return 0;
}

 

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值